#version 150
#extension GL_ARB_separate_shader_objects : enable

layout(points) in;
layout(triangle_strip, max_vertices = 4) out;

//in float io_scale[1];
   
uniform mat4 u_projection;
uniform mat4 u_view;
uniform vec3 u_camera;
uniform float u_scale;

out vec2 TexCoord;
   
void main()
{
   vec3 pos = gl_in[0].gl_Position.xyz;
   vec3 to = u_camera - pos;
   vec3 right = normalize(cross(to, vec3(0,1,0)));
   vec3 up = normalize(cross(right, to));
   
   right *= u_scale;
   up *= u_scale;
   
   // Vertex 1
   pos += 0.5 * right;
   gl_Position = u_projection * u_view * vec4(pos, 1.0);
   TexCoord = vec2(0.0, 0.0);
   EmitVertex();
   
   // Vertex 2
   pos += up;
   gl_Position = u_projection * u_view * vec4(pos, 1.0);
   TexCoord = vec2(0.0, 1.0);
   EmitVertex();
   
   // Vertex 3
   pos -= up;
   pos -= right;
   gl_Position = u_projection * u_view * vec4(pos, 1.0); 
   TexCoord = vec2(1.0, 0.0);
   EmitVertex();
   
   // Vertex 3
   pos += up;
   gl_Position = u_projection * u_view * vec4(pos, 1.0);
   TexCoord = vec2(1.0, 1.0);
   EmitVertex();
   
   // Done!
   EndPrimitive();
}