#version 150

in vec3 i_normal;
in vec3 i_position;
in vec2 i_texcoord;

uniform mat4 u_model;
uniform mat4 u_view;
uniform mat4 u_projection;

out vec3 io_eyeVec;
out vec3 io_lightVec;
out vec3 io_normal;
out vec2 io_uv;

void main() {

   gl_Position = u_projection * u_view * u_model * vec4(i_position, 1.0);

   vec3 vVertex = vec3(u_view * u_model * vec4(i_position, 1.0));
   vec3 lightPos = vec3(10.0, 10.0, 0.0);

   io_lightVec = lightPos - vVertex;
   io_eyeVec = -vVertex;
   io_normal = vec3(u_model * vec4(i_normal, 0.0));
   io_uv = i_texcoord;
}
