#version 150

in vec3 i_normal;
in vec3 i_position;
in vec2 i_texcoord;

uniform mat4 u_model;
uniform mat4 u_view;
uniform mat4 u_projection;

out vec3 io_color;
out vec2 io_uv;

void main() {

   gl_Position = u_projection * u_view * u_model * vec4(i_position, 1.0);

   vec3 norm = normalize((transpose(inverse(u_view * u_model)) * vec4(i_normal, 0.0)).xyz);

   vec3 light = normalize(vec3(1.0));

   vec3 ambient = vec3(0.2);
   vec3 diffuse = vec3(0.5 * max(dot(light, norm), 0.0));
   vec3 specular = vec3(0.0);

   io_uv = i_texcoord;
   io_color = ambient + diffuse + specular;
}
