#version 150

uniform sampler2D u_texture;

in vec2 io_uv;
in vec3 io_normal;
out vec4 o_color;

void main() {

   vec3 L = normalize(vec3(1.0, 1.0, 1.0));
   vec3 U = vec3(0.0, 0.0, 1.0);
   vec3 N = normalize(io_normal);

   vec4 color = texture(u_texture, io_uv);

   vec4 ambient = color * 0.4;
   vec4 diffuse = color * (0.8 * max(dot(N, L), 0.0));
   vec4 specular = vec4(0.0);


   if (dot(N, L) > 0.7) {
      specular = color * (0.3 * dot(N, L));
   }

   o_color = texture(u_texture, io_uv);//color;//ambient + diffuse + specular;
}
