#version 150

in vec3 i_normal;
in vec3 i_position;
in vec2 i_texcoord;

uniform mat4 u_model;
uniform mat4 u_view;
uniform mat4 u_projection;

out vec3 io_normal;
out vec3 io_eye;
out vec2 io_uv;
out vec3 io_pos;

void main() {

   vec4 pos = u_projection * vec4(i_position, 1.0);

   io_normal = i_normal;
   io_eye = vec3(-1.0*pos.x, -1.0*pos.y, -1.0*pos.z);
   io_uv = i_texcoord;
   io_pos = vec3(pos);
   gl_Position = pos;
}
